/*====================================================================

Objectweb Browser Framework
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.api;

/**
 * Offers a contextual view on the tree.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>,
 *         <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>
 * 
 * @version 0.2
 */
public interface TreeView 
{

    /**
     * Returns the current selected Entry.
     */
    public Entry 
    getSelectedEntry();

    /**
     * Returns the parent entry of the current selected entry.
     */
    public Entry 
    getParentEntry();

    /**
     * Returns the value of the current selected Entry.
     * Equivalent to <code>getSelectedEntry().getValue()</code>.
     */
    public Object 
    getSelectedObject();

    /**
     * Returns the value of the parent entry.
     * Equivalent to <code>getParentEntry().getValue()</code>.
     */
    public Object 
    getParentObject();
    
    /**
     * Returns an object to manipulate the Tree.
     */
    public Tree
    getTree();
    
}
