/*===========================================================================

ObjectWeb Naming Context Framework
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.util.browser.core.panel;

/** The Java API's imports */
import javax.swing.JLabel;
import javax.swing.JTextField;
import java.awt.Dimension;
import javax.swing.BoxLayout;
import javax.swing.Box;

/**
 * This class represents a Parameter
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class ParameterGUI extends Box {

    protected Class class_;
    protected JLabel label_;
    protected JTextField value_;

    public ParameterGUI(Class class_) {
        super(BoxLayout.X_AXIS);
        this.class_ = class_;
        int lastIndex = class_.getName().lastIndexOf('.');
        if (lastIndex != -1)
            label_ = new JLabel(class_.getName().substring(lastIndex + 1));
        else
            label_ = new JLabel(class_.getName());
        label_.setPreferredSize(new Dimension(100, 20));
        add(label_);
        value_ = new JTextField(15);
        value_.setPreferredSize(new Dimension(330, 20));
        add(value_);
    }

    public Class getParameterClass() {
        return class_;
    }

    public String getParameterValue() {
        return value_.getText();
    }
}
