@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
rem # Contact: openccm@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Sylvain Leblanc.
rem # Contributor(s): Philippe Merle, Christophe Demarey.
rem #
rem # ====================================================================
rem #
rem # Starting the Community OpenORB 1.4.0 CosTrading Service.
rem #
rem # ====================================================================

setlocal

rem # Check if the OpenCCM Platform is installed.
call "%OpenCCM_HOMEDIR%\bin\ccm_installed"
if %CCM_INSTALLED%==0 goto :eof

rem # Check if the CosTrading Service is already started.
if not exist "%OpenCCM_CONFIG_DIR%\TradingService.IOR" goto :not_exist

echo Error: The CosTrading Service is already started!
goto :eof

:not_exist

rem # Check if the OpenCCM Platform is installed.
call "%OpenCCM_HOMEDIR%\bin\ccm_installed"
if %CCM_INSTALLED%==0 goto :eof

:do_start

echo The CosTrading Service will be started.

rem # Remove the lookup.ior and strep.ior files
rem # else the following while instruction
rem # could consider that the CosTrading Service
rem # is started and this is not the case
rem # if the files were already present.
if exist Kernel.ior del Kernel.ior
if exist strep.ior del strep.ior

echo Launching The Community OpenORB 1.4.0 CosTrading Service.

set LAUNCHER_ARGS="file:%OpenCCM_HOMEDIR%/xml/launcher/Trader.xml"
call openccm_launcher fork "%OpenCCM_CONFIG_DIR%\TradingService.output" "%OpenCCM_CONFIG_DIR%\TradingService.PID"

rem # Wait for the lookup.ior file produced
rem # by the Community OpenORB 1.4.0 CosTrading Service.
:wait
set READY=
if not exist Kernel.ior goto :wait
for /f %%i in (Kernel.ior) do set READY=ok
if not defined READY goto :wait

rem # Move it into the OpenCCM configuration directory.
move Kernel.ior "%OpenCCM_CONFIG_DIR%\TradingService.IOR"

rem # Remove it as not currently used.
if exist strep.ior del strep.ior

echo Feeding the CosTrading Service Type Repository with OpenCCM basic service types.
call trader_feed "%OpenCCM_HOMEDIR%/xml/trader/basic.xml"

echo The CosTrading Service is started.
