/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.openccm.task;

// Package dependencies.

/**
 * This is a representation of a package mapping declaration.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 0.1
 */
public class PackageMapping
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    /** The IDL package name. */
    String idl_pkg_;

    /** The java package name. */
    String java_pkg_;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    
    /**
     * The default constructor.
     */
    public 
    PackageMapping()
    {
        // Init internal states
        idl_pkg_ = null;
        java_pkg_ = null;
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    protected String
    asArgument()
    {
        return idl_pkg_ + ":" + java_pkg_;   
    }
    
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
    
    /**
     * Set the IDL package name to map.
     *
     * @param name - The package name.
     */
    public void
    setIdlpkg(String name)
    {
        idl_pkg_ = name;
    }

    /**
     * Set the Java package name to map.
     *
     * @param name - The package name.
     */
    public void
    setJavapkg(String name)
    {
        java_pkg_ = name;
    }
}
