/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Offroy.
Contributor(s): ______________________________________.

====================================================================*/
/*
 * Created on 23 mai 2003 by jerome OFFROY (offroy@lifl.fr)
 *
 */

package org.omg.lifl.eclipse.plugin.project.OpenCCM.utils;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;
import org.omg.lifl.eclipse.plugin.project.utils.AttributeManager;
import org.omg.lifl.eclipse.plugin.project.utils.SWT.CheckGroup;

/**
 * @author Jerome Offroy offroy@lifl.fr 
 *
 */
public class CVSsrcFSChooser {

	private String _CVSsrcFSPathValue;
	private String _CVSsrcFSPathLabel;
	private String _CVFsrcFSGroupLabel;
	private Text CVSsrcFSTextPath;

	private DirectoryDialog fd1;
	private CheckGroup checkGroup;
	/**
	 * @param pageNumber
	 * @param elem
	 */
	public CVSsrcFSChooser(IConfigurationElement elem) {
		_CVSsrcFSPathValue =
			AttributeManager.getAttribute(elem, "CVSsrcFSPathValue");
		_CVSsrcFSPathLabel =
			AttributeManager.getAttribute(elem, "CVSsrcFSPathLabel");
		_CVFsrcFSGroupLabel = "";
	}

	/**
	 * @param composite
	 */
	public void viewToSetCVSsrcFS(Composite composite) {
        String buttonTittle = ProjectMessages.getString("DirectoryChooser.BrowseButtonLabel");
        checkGroup = new CheckGroup(composite, "Source Import Config");

		Group group_1 = new Group(checkGroup.getGroup(), SWT.NONE);
		checkGroup.setSubGroup(group_1);

		group_1.setLayout(new RowLayout());
		group_1.setText(_CVFsrcFSGroupLabel);

		Label label2 = new Label(group_1, SWT.LEFT);
		label2.setText(_CVSsrcFSPathLabel);
		CVSsrcFSTextPath = new Text(group_1, SWT.SINGLE | SWT.BORDER);
		CVSsrcFSTextPath.setText(_CVSsrcFSPathValue);
		CVSsrcFSTextPath.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				//TODO add verification for the OpenCCM source folder 
				set_CVSsrcFSPathValue(CVSsrcFSTextPath.getText());
			}
		});
		fd1 = new DirectoryDialog(composite.getShell());
		fd1.setFilterPath(get_CVSsrcFSPathValue());
		Button btn = new Button(group_1, SWT.NONE);
		btn.setText(buttonTittle);

		btn.addListener(SWT.Selection, new Listener() {

			public void handleEvent(Event e) {
				String buffer = fd1.open();
				if (buffer != null)
					configCVSsrcFS(buffer);
			}
		});
	}

	/**
	 * @param buffer
	 */
	protected void configCVSsrcFS(String buffer) {
		set_CVSsrcFSPathValue(buffer);
		CVSsrcFSTextPath.setText(buffer);
	}

	/**
	 * @param string
	 */
	public void set_CVSsrcFSPathValue(String string) {
		_CVSsrcFSPathValue = string;
	}

	/**
	 * @return
	 */
	public String get_CVSsrcFSPathValue() {
		return _CVSsrcFSPathValue;
	}

	/**
	 * @return
	 */
	public CheckGroup getCheckGroup() {
		return checkGroup;
	}

	/**
	 * @param group
	 */
	public void setCheckGroup(CheckGroup group) {
		checkGroup = group;
	}

}
