package ist.coach.coachEmfClientComponents.gui;

import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableModel;
import java.awt.Color;

public class JLogTable
extends JTable {


	DefaultTableCellRenderer eventTypeRenderer;
	DefaultTableCellRenderer readonlyRenderer;
	DefaultTableCellRenderer detailsRenderer;
	DefaultTableCellRenderer errorLogTypeRenderer;

	LogTableModel logData;

	public JLogTable(LogTableModel dm) {
		super(dm);

		logData = dm;
		eventTypeRenderer = new DefaultTableCellRenderer();
		eventTypeRenderer.setForeground(Color.blue);
		eventTypeRenderer.setFont(new java.awt.Font("Helvetica",
												java.awt.Font.BOLD, 10));

		detailsRenderer = new DefaultTableCellRenderer();
		detailsRenderer.setFont(new java.awt.Font("Helvetica",
					    java.awt.Font.BOLD, 6));

		readonlyRenderer =  new DefaultTableCellRenderer();
		readonlyRenderer.setFont(new java.awt.Font("Arial",
					    java.awt.Font.PLAIN, 6));

		errorLogTypeRenderer = new DefaultTableCellRenderer();
		errorLogTypeRenderer.setForeground(Color.red);
		getTableHeader().setFont(new java.awt.Font("Helvetica",
                                    java.awt.Font.BOLD, 12));
	}

	public TableCellRenderer getCellRenderer(int row, int column) {

		if (((String) logData.getValueAt(row, LogTableModel.EVENT_C)).
		  trim().equals(GuiMaster.ERROR_LOG))
		  return errorLogTypeRenderer;

		if (column == LogTableModel.EVENT_C)
			return eventTypeRenderer;
		if (column == LogTableModel.DETAILS_C)
		    return detailsRenderer;

		return readonlyRenderer;
	}
}
