package ist.coach.coachEmfClientComponents.gui;

import javax.swing.table.AbstractTableModel;

class ParamTableModel extends AbstractTableModel {

        final String[] columnNames = {"Attribute", "Value"};
        Object[][] data = null;
		boolean[] param_options = null;

        ParamTableModel(String []params) {

			data = new Object[params.length][2];
            for(int i = 0; i < params.length; i++) {
                 //GuiClient.println("params[i] = " + params[i]);
                data[i][0] = params[i];
                data[i][1] = new String();
            }
        }

		ParamTableModel(String []params, Object[] values, boolean[] param_options) {

            data = new Object[params.length][2];
			this.param_options = param_options;
            for(int i = 0; i < params.length; i++) {
                 //GuiClient.println("params[i] = " + params[i]);
                data[i][0] = params[i];
                data[i][1] = values[i];
            }
        }


        public int getColumnCount() {
            return columnNames.length;
        }

        public int getRowCount() {
            return data.length;
        }

        public String getColumnName(int col) {
            return columnNames[col];
        }

        public Object getValueAt(int row, int col) {
            return data[row][col];

        }

        /*
         * JTable uses this method to determine the default renderer/
         * editor for each cell.  If we didn't implement this method,
         * then the last column would contain text ("true"/"false"),
         * rather than a check box.
         */
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }

        /*
         * Don't need to implement this method unless your table's
         * editable.
         */
        public boolean isCellEditable(int row, int col) {
            //Note that the data/cell address is constant,
            //no matter where the cell appears onscreen.
            if (col <1) {
                return false;
            } else {

				if (param_options != null && param_options.length > row) 
                		return param_options[row];
				else
					return true;
            }
        }

        public void setValueAt(Object value, int row, int col) {

         // GuiClient.println("Setting value at " + row + "," + col
         //                          + " to " + value
         //                           + " (an instance of "
         //                           + value.getClass() + ")");
         //
            data[row][col] = value;
            fireTableCellUpdated(row, col);
          //  GuiClient.println("New value of data:");
          // printDebugData();
        }

        public void printDebugData() {
            int numRows = getRowCount();
            int numCols = getColumnCount();

            for (int i=0; i < numRows; i++) {
                GuiClient.print("    row " + i + ":");
                for (int j=0; j < numCols; j++) {
                    GuiClient.print("  " + data[i][j]);
                }
                GuiClient.println("");
            }
            GuiClient.println("--------------------------");
        }
    }

