/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmfServicesComponents.BasicLogProviderComposition;

import ist.coach.coachEmfCommon.LogAttributeValueChangeFactory;
import ist.coach.coachEmfCommon.LogThresholdAlarmFactory;
import ist.coach.coachEmfCommon.NamePrimaryKeyFactory;
import ist.coach.coachEmfCommon.LogNewRecordFactory;

import ist.coach.coachEmfServicesComponents.BasicLogProvider;
//import ist.coach.coachEmfServicesComponents.BasicLogProviderHelper;
//import ist.coach.coachEmfServicesComponents.BasicLogHomeHelper;

import ist.coach.coachEmfServicesComponents.BasicLogProviderComposition.*;

import java.util.Vector;
import java.util.Enumeration;
/**
 *  This is the CIDL-based implementation of
 *  OMG IDL3 IDL:coach.ist/coachEmfServicesComponents/BasicLogProviderHome:1.0 home type.
 *
 *  This class inherits from the generated home executor skeleton class
 *  defined by OMG CIDL ist.coach.coachEmfServicesComponents.BasicLogProviderComposition.BasicLogProviderSimpleHome_impl
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class BasicLogProviderHomeImpl
     extends ist.coach.coachEmfServicesComponents.BasicLogProviderComposition.BasicLogProviderSimpleHome_impl
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
	private Vector allExistingLogs_;


    // ==================================================================
    //
    // Constructors.
    //

    // ==================================================================

    public BasicLogProviderHomeImpl()
    {
	    allExistingLogs_ = new Vector();
    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     *  Method for the org.objectweb.ccm.runtime.cif.api.SegmentHome interface.
     *
     *  Create an executor segment from its identifier.
     *
     *  @param segid - The executor segment identifier.
     *
     *  @return - The executor segment created.
     */
    public org.omg.Components.ExecutorSegmentBase
    create_executor_segment(int segid)
    {


        switch (segid)
        {
            case ist.coach.coachEmfServicesComponents.BasicLogProviderComposition.basicLogSegImpl._segment_id_value :

				return new ist.coach.coachEmfServicesComponents.BasicLogProviderComposition.basicLogSegImpl();
            default :
			    ist.coach.coachEmfServicesComponents.BasicLogProviderComposition.BasicLogProviderImpl new_logProvider =
				new ist.coach.coachEmfServicesComponents.BasicLogProviderComposition.BasicLogProviderImpl();

				return new_logProvider;
        }
    }
/****
	public org.omg.Components.EnterpriseComponent
	create() {
	  System.err.println("BasicLogProviderHome> custom create called!!!");
	  BasicLogProviderImpl new_log_provider = (BasicLogProviderImpl) super.create();
	  allExistingLogs_.add(new_log_provider);
	  System.err.println("BasicLogProviderHome> custom create returns!!!");
	  return (org.omg.Components.EnterpriseComponent) new_log_provider;
	}
****/
    /**
     *  This method is called by the OpenCCM Component Server
     *  to create a home instance.
     *
     *  @return - The created home.
     */
    public static org.omg.Components.HomeExecutorBase
    create_home()
    {

		BasicLogProviderHomeImpl home =  new BasicLogProviderHomeImpl();
	    return home;
    }


    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::LogMgr::list_logs operation.
     */
    public ist.coach.coachEmfServices.EmfBasicLog.BasicLog[]
    list_logs()
    {
	    //
        // DONE : Implement
        //
        ist.coach.coachEmfServices.EmfBasicLog.BasicLog[] logs_list =
			  new ist.coach.coachEmfServices.EmfBasicLog.BasicLog[allExistingLogs_.size()];

		for(int i = 0; i < logs_list.length; i++)
		  logs_list[i] = ((BasicLogProvider) allExistingLogs_.elementAt(i)).provide_i_BasicLog();
		  //allExistingLogs_.copyInto(logs_list);

		return logs_list;
    }


    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::LogMgr::list_logs_by_id operation.
     */
    public int[]
    list_logs_by_id()
    {
        //
        // DONE : Implement
        //
		int[] logs_by_id = new int[allExistingLogs_.size()];
		int i = 0;
        for (Enumeration e = allExistingLogs_.elements() ; e.hasMoreElements() &&
			    i < logs_by_id.length ; i++) {
			logs_by_id[i] = ((BasicLogProvider) e.nextElement()).logId();

		}

		return logs_by_id;
    }


	// Executed once at the loading of this class
    // by the OpenCCM Component Server.
    static {

		LogAttributeValueChangeFactory.register();
		LogThresholdAlarmFactory.register();
		NamePrimaryKeyFactory.register();
		LogNewRecordFactory.register();

	}

}
