/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmfServicesComponents.SnmpAdapterProviderComposition;

//import ist.coach.coachEmfServicesComponents.SnmpObjectData;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;
import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ExceptionMessages;

import org.omg.CosNaming.NameComponent;

import java.util.LinkedList;
import java.util.ListIterator;


/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/coachEmfServicesComponents/SnmpAdapterProviderComposition/SnmpAdapterProviderHome_impl/SnmpAdapterProvider_impl/configSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class configSegImpl
     extends ist.coach.coachEmfServicesComponents.SnmpAdapterProviderComposition.configSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public configSegImpl()
    {
    }
    // ==================================================================
    //
    // Private Methods.
    //
    // ==================================================================
    private boolean nameExists(NameComponent[] name) {

		ListIterator li = SnmpAdapterProviderImpl.linkedList.listIterator();

		while (li.hasNext()) {
			SnmpObjectData objData = (SnmpObjectData) li.next();
			if (objData.getName().equals(name)) {
				return true;
			}
		}
		return false;
   	 }

	 private boolean rootObjectExists(String ipAddress,
		NameComponent[] name) {

		ListIterator li = SnmpAdapterProviderImpl.linkedList.listIterator();

		while (li.hasNext()) {

			SnmpObjectData objData = (SnmpObjectData)li.next();
			//System.err.println("Examining object with IPAddress = *" +
			  //objData.getIPAddress() + "* against *" + ipAddress + "*");

			if (objData.getIPAddress().equals(ipAddress) &&
				SnmpAdapterProviderImpl.isRootObject(
				  SnmpAdapterProviderImpl.getObjectClass(objData.getName())) &&
				  Utils.isChild(name, objData.getName()))
					return true;
		}

		return false;
    }

	private SnmpObjectData findObjectWithName(NameComponent[] name) {

		String name_str = Utils.name2string(name);

		ListIterator li = SnmpAdapterProviderImpl.linkedList.listIterator();

		SnmpObjectData objData = null;

		while (li.hasNext()) {
			objData = (SnmpObjectData) li.next();
			if (Utils.name2string(objData.getName()).equals(name_str)) {
				return objData;
			}
		}
		return null;
   	 }
    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::SnmpTrapDaemon::registerIP operation.
     */
    public void
    registerIP(org.omg.CosNaming.NameComponent[] name, String ipAddress)
    throws ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError
    {
         //
        //  DONE : implement
        //
	if (nameExists (name)) {
		System.err.println("Could not register object with Name " +
				Utils.name2string(name) + " because it already exists!");
		throw new SnmpApplicationError(ExceptionMessages.snmp_register_error);

	}
	else {
		SnmpObjectData objData = new SnmpObjectData (name, ipAddress);
		synchronized(SnmpAdapterProviderImpl.linkedList) {
		  SnmpAdapterProviderImpl.linkedList.add(objData);
		}
		//System.err.println("SnmpAdapter> Registered object with Name " +
			//Utils.name2string(name) + " and IP Address *" + ipAddress + "*");
	}
    }

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::SnmpTrapDaemon::registerValue operation.
     */
    public void
    registerValue(org.omg.CosNaming.NameComponent[] name, String ipAddress, org.omg.CORBA.Any value)
    throws ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError
    {
       //
        //  DONE : implement
        //
	//System.err.println("SnmpAdapter:registerValue> is called for " +
	//  Utils.name2string(name) + " with IP Address *" + ipAddress + "*");
	if (nameExists (name)) {
		System.err.println("SNMPAdapter:registerValue> Could not register object with Name "
		  + Utils.name2string(name) + " because it already exists!");
		throw new SnmpApplicationError(ExceptionMessages.snmp_register_error);
	}
	else
		if (rootObjectExists(ipAddress, name) == false) {
			System.err.println("SNMPAdapter:registerValue> Could not find parent for this object.");
			throw new SnmpApplicationError(ExceptionMessages.snmp_superior_error);
		}
		else {
			SnmpObjectData objData = new SnmpObjectData (name, ipAddress, value);
			synchronized(SnmpAdapterProviderImpl.linkedList) {
			  SnmpAdapterProviderImpl.linkedList.add(objData);
			}
			//System.err.println("Registered object with Name " + Utils.name2string(name) + " and IP Address " + ipAddress);
		}
    }

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::SnmpTrapDaemon::unregister operation.
     */
    public void
    unregister(org.omg.CosNaming.NameComponent[] name)
    throws ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError
    {
       //
        //  DONE : implement
        //

	  SnmpObjectData objData = null;

	  if ((objData = findObjectWithName(name)) != null) {
		synchronized(SnmpAdapterProviderImpl.linkedList) {
		  SnmpAdapterProviderImpl.linkedList.remove(objData);
		}
		System.err.println("SnmpAdapter:unregister>Unregistered object with name " + Utils.name2string(name));
	  }
	  else {
		System.err.println("SnmpAdapter:unregister>Could not unregister object with name " + Utils.name2string(name));
		throw new SnmpApplicationError(ExceptionMessages.snmp_unregister_error);
	  }
    }

}
