/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmsMibComponents.IpToMACAddressProviderComposition;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.ApplicationError;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ObjectCreationImpl;

import intt.itu.itut_x780.AttributeValueType;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;

import org.omg.CosNaming.NameComponent;

import java.util.Hashtable;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/coachEmsMibComponents/IpToMACAddressProviderComposition/IpToMACAddressProviderHome_impl/IpToMACAddressProvider_impl/mgmtSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class mgmtSegImpl
     extends ist.coach.coachEmsMibComponents.IpToMACAddressProviderComposition.mgmtSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public mgmtSegImpl()
    {
    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::coachEmsMibComponents::IpToMACAddressMgmt::create operation.
     */
    public void
    create(org.omg.CosNaming.NameComponent[] name,
		    String objectClass,
			String[] packages,
			short deletePolicy,
			intt.itu.itut_x780.SourceIndicatorType sourceIndicator,
			org.omg.CosNaming.NameComponent[] superior,
			int ipNetToMediaIfIndex,
			byte[] ipNetToMediaNetAddress,
			byte[] mgmtIpAddress,
			int supportedSnmpVersions,
			int snmpPort)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_x780.CreateError
    {
        if (IpToMACAddressProviderImpl.elements.containsKey(Utils.name2string(name))) {

            CreateErrorInfoTypeImpl errorCode =
                new CreateErrorInfoTypeImpl();

            errorCode.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.duplicateName.value);

            errorCode.details = new String(Utils.name2string(name) +
             " object already exists.");
            throw new intt.itu.itut_x780.CreateError(errorCode);
        }

		IpToMACAddressDataStructure iptoMACAddress =
			new IpToMACAddressDataStructure(
				ipNetToMediaIfIndex,
				ipNetToMediaNetAddress,
				name,
                objectClass,
                packages,
                sourceIndicator,
                deletePolicy,
				new String(mgmtIpAddress),
                snmpPort,
                supportedSnmpVersions);

		synchronized(IpToMACAddressProviderImpl.elements) {
		  IpToMACAddressProviderImpl.elements.put(Utils.name2string(name), iptoMACAddress);
		}
		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT (System.currentTimeMillis(),
                    0, (short) 0, (short) 0);
        get_context().push_objectCreation(new ObjectCreationImpl(eventTime,
                                                name,
                                                objectClass,
												IpToMACAddressProviderImpl.getUniqueNotificationIdentifier(),
												sourceIndicator,
                                                new AttributeValueType[0]));
		//System.err.println("IpToMACAddressProviderImpl:mgmtSeg : objectCreation alarm should have been sent!");
    }

    /**
     * Implementation of the ::coachEmsMibComponents::IpToMACAddressMgmt::facade_name operation.
     */
    public String
    facade_name()
    {
         //
        // DONE : Implement
        //
        return get_main_segment().facade_name();
    }

}
