/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmsMibComponents.SnmpProtocolMonitorProviderComposition;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.AttributeValueType;

import ist.coach.coachEmfCommon.Utils;

import ist.coach.coachEmfCommon.ObjectDeletionImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;

import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.DataTypeImpl;
import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;
import ist.coach.coachEmsMib.SnmpProtocolMonitorValueType;

import ist.coach.coachEmsCommon.SnmpIdentifiers;

import ist.coach.coachEmsCommon.SnmpProtocolMonitorValueTypeImpl;
import org.omg.CosNaming.NameComponent;
import org.omg.CORBA.TCKind;

import org.opennms.protocols.snmp.SnmpSMI;
import ist.coach.coachEmfServices.EmfBasicLog.*;
import java.util.Hashtable;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 IDL:coach.ist/coachEmsMibComponents/SnmpProtocolMonitorProvider:1.0 component type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class SnmpProtocolMonitorProviderImpl
     extends ist.coach.coachEmsMibComponents.SnmpProtocolMonitorProviderComposition.SnmpProtocolMonitorProvider_impl
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
   org.omg.CORBA.ORB orb = null;
    private String _facade_name;

    protected static  Hashtable elements;
	private static int notifId = 12000;
	private BasicLog logSupport;

    ist.coach.coachEmfServices.SnmpAdapter.SnmpConnector connector = null;

	private static final String SNMP_AUTH_CONFIG_PACKAGE = "snmpEnableAuthenTrapPackage";

	private static final String READ_COMMUNITY = SnmpIdentifiers.READ_COMMUNITY;
	private static final String WRITE_COMMUNITY = SnmpIdentifiers.WRITE_COMMUNITY;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public SnmpProtocolMonitorProviderImpl()
    {
	  elements = new Hashtable();
    }

    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

		if ((connector = get_context().get_connection_connector()) == null)
            throw new org.omg.Components.InvalidConfiguration();
		if ((logSupport = get_context().get_connection_basic_log()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		orb = org.objectweb.ccm.CORBA.TheORB.getORB();

        System.err.println("SnmpProtocolMonitorProvider configuration completed...");


    }    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as accessor operation.
     */
    public String
    facade_name()
    {
        //
        //  DONE : implement
        //
        return _facade_name;
    }

    /**
     * Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as mutator operation.
     */
    public void
    facade_name(String val)
    {
             //
        //  DONE : implement
        //
		if (val != null)
            _facade_name = new String(val);
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInPktsGet operation.
     */
    public long
    snmpInPktsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INPKTS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInPkts " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INPKTS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInPkts " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INPKTS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;

    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpOutPktsGet operation.
     */
    public long
    snmpOutPktsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_OUTPKTS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpOutPkts " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTPKTS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpOutPkts " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTPKTS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;

    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInBadVersionsGet operation.
     */
    public long
    snmpInBadVersionsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INBADVERSIONS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInBadVersions " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INBADVERSIONS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInBadVersions " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INBADVERSIONS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;

    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInBadCommunityNamesGet operation.
     */
    public long
    snmpInBadCommunityNamesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INBADCOMMUNITYNAME_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInBadCommunityNames " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INBADCOMMUNITYNAME_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInBadCommunityNames " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INBADCOMMUNITYNAME_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;

    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInBadCommunityUsesGet operation.
     */
    public long
    snmpInBadCommunityUsesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INBADCOMMUNITYUSES_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInBadCommunityUses " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INBADCOMMUNITYUSES_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInBadCommunityUses " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INBADCOMMUNITYUSES_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInASNParseErrsGet operation.
     */
    public long
    snmpInASNParseErrsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INASNPARSEERRORS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInASNParseErrs " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INASNPARSEERRORS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInASNParseErrs " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INASNPARSEERRORS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInTooBigsGet operation.
     */
    public long
    snmpInTooBigsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INTOOBIG_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInTooBigs " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INTOOBIG_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInTooBigs " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INTOOBIG_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInNoSuchNamesGet operation.
     */
    public long
    snmpInNoSuchNamesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INNOSUCHNAMES_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInNoSuchNames " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INNOSUCHNAMES_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInNoSuchNames " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INNOSUCHNAMES_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInBadValuesGet operation.
     */
    public long
    snmpInBadValuesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INBADVALUES_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInBadValues " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INBADVALUES_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInBadValues " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INBADVALUES_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInReadOnlysGet operation.
     */
    public long
    snmpInReadOnlysGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INREADONLYS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInReadOnlys " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INREADONLYS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInReadOnlys " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INREADONLYS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInGenErrsGet operation.
     */
    public long
    snmpInGenErrsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INGENERRS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInGenErrs " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INGENERRS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInGenErrs " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INGENERRS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInTotalReqVarsGet operation.
     */
    public long
    snmpInTotalReqVarsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
       //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INTOTALREQVARS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInTotalReqVars " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INTOTALREQVARS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInTotalReqVars " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INTOTALREQVARS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInTotalSetVarsGet operation.
     */
    public long
    snmpInTotalSetVarsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
       //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INTOTALSETVARS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInTotalSetVars " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INTOTALSETVARS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInTotalSetVars " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INTOTALSETVARS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInGetRequestsGet operation.
     */
    public long
    snmpInGetRequestsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
       //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INGETREQS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInGetRequests " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INGETREQS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInGetRequests " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INGETREQS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInGetNextsGet operation.
     */
    public long
    snmpInGetNextsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
       //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INGETNEXTS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInGetNexts " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INGETNEXTS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInGetNexts " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INGETNEXTS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInSetRequestsGet operation.
     */
    public long
    snmpInSetRequestsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
       //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INSETREQS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInSetRequests " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INSETREQS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInSetRequests " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INSETREQS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInGetResponsesGet operation.
     */
    public long
    snmpInGetResponsesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INGETRESPONSES_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInGetResponses " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INGETRESPONSES_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInGetResponses " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INGETRESPONSES_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpInTrapsGet operation.
     */
    public long
    snmpInTrapsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_INTRAPS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpInTraps " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INTRAPS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpInTraps " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_INTRAPS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpOutTooBigsGet operation.
     */
    public long
    snmpOutTooBigsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
         //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_OUTTOOBIG_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpOutTooBigs " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTTOOBIG_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpOutTooBigs " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTTOOBIG_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpOutNoSuchNamesGet operation.
     */
    public long
    snmpOutNoSuchNamesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_OUTNOSUCHNAMES_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpOutNoSuchNames " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTNOSUCHNAMES_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpOutNoSuchNames " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTNOSUCHNAMES_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpOutBadValuesGet operation.
     */
    public long
    snmpOutBadValuesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_OUTBADVALUES_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve  snmpOutBadValues " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTBADVALUES_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve  snmpOutBadValues " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTBADVALUES_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpOutGenErrsGet operation.
     */
    public long
    snmpOutGenErrsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_OUTGENERRS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve  snmpOutGenErrs " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTGENERRS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve  snmpOutGenErrs " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTGENERRS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpOutGetRequestsGet operation.
     */
    public long
    snmpOutGetRequestsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_OUTGETREQS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve  snmpOutGetRequests " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTGETREQS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve  snmpOutGetRequests " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTGETREQS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpOutGetNextsGet operation.
     */
    public long
    snmpOutGetNextsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_OUTGETNEXTS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve  snmpOutGetNexts " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTGETNEXTS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve  snmpOutGetNexts " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTGETNEXTS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpOutSetRequestsGet operation.
     */
    public long
    snmpOutSetRequestsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_OUTSETREQS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve snmpOutSetRequests " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTSETREQS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpOutSetRequests " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTSETREQS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpOutGetResponsesGet operation.
     */
    public long
    snmpOutGetResponsesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
         //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_OUTGETRESPONSES_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve   snmpOutGetResponses " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTGETRESPONSES_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpOutGetResponses " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTGETRESPONSES_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpOutTrapsGet operation.
     */
    public long
    snmpOutTrapsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
         //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_OUTTRAPS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve   snmpOutTraps " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTTRAPS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpOutTraps " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_OUTTRAPS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  long snmpAttrValue = value.extract_longlong();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpEnableAuthenTrapsGet operation.
     */
    public int
    snmpEnableAuthenTrapsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
         //
        //  DONE : implement
        //
	  String key = Utils.name2string(name);

	  if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  DataType snmpAttrData = null;

	  try {
		snmpAttrData = connector.get(
			SnmpIdentifiers.SNMP_ENABLEAUTHTRAPS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	  }
	  catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve   snmpEnableAuthenTraps " +
				"for SnmpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_ENABLEAUTHTRAPS_OID +
				" does not exist.");

		    Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting snmpInPkts: " + e.reason);

		  throw new ApplicationError (error_code);
	  }

	  org.omg.CORBA.Any value = snmpAttrData.value;

	  if (value.type().kind().value() != TCKind._tk_long) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve snmpEnableAuthenTraps " +
			"for SnmpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.SNMP_ENABLEAUTHTRAPS_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	  }

	  int snmpAttrValue = value.extract_long();

	  return snmpAttrValue;
    }

    /**
     * Implementation of the ::coachEmsMib::SnmpProtocolMonitor_F::snmpEnableAuthenTrapsSet operation.
     */
    public void
    snmpEnableAuthenTrapsSet(org.omg.CosNaming.NameComponent[] name, int snmpEnableAuthenTraps)
    throws intt.itu.itut_x780.ApplicationError,
     ist.coach.coachEmsMib.NOsnmpEnableAuthenTrapsPackageException
    {
        	String key = Utils.name2string(name);

	  if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	  }

	  if (!Utils.packageIsSupported(SNMP_AUTH_CONFIG_PACKAGE,
			packagesGet(name))) {
		System.out.println("Package " + SNMP_AUTH_CONFIG_PACKAGE +
			"is not supported by SnmpProtocolMonitor Object" + key);

		throw new ist.coach.coachEmsMib.NOsnmpEnableAuthenTrapsPackageException();
	  }

	  SnmpProtocolMonitorDataStructure data =
		(SnmpProtocolMonitorDataStructure) elements.get(key);

	  org.omg.CORBA.Any value = orb.create_any();
	    value.insert_long(snmpEnableAuthenTraps);

	  DataTypeImpl snmpAttrData = new DataTypeImpl(
		  SnmpIdentifiers.SNMP_ENABLEAUTHTRAPS_OID,
		  value,
		 SnmpSMI.SMI_INTEGER);

	  try {

		this.connector.set(
			snmpAttrData,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			SnmpIdentifiers.WRITE_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

		    ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		  else
			error_code.details = new String ("Could not set snmpEnableAuthenTraps " +
				 "for SnmpProtocolMonitor Object with name " + key + ".");

		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error setting the contact details: " + e.reason);
		throw new ApplicationError(error_code);

	}
	Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "snmpEnableAuthenTraps set to " + snmpEnableAuthenTraps);
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::nameGet operation.
     */
    public org.omg.CosNaming.NameComponent[]
    nameGet()
    {
        //
        // DONE : Implement
        //
        return Utils.string2name(_facade_name);
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::objectClassGet operation.
     */
    public String
    objectClassGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
         //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		SnmpProtocolMonitorDataStructure data =
			(SnmpProtocolMonitorDataStructure) elements.get(key);

		return data.objectclass;

    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::attributesGet operation.
     */
    public intt.itu.itut_x780.ManagedObjectValueType
    attributesGet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.StringSetTypeHolder attributeNames)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		SnmpProtocolMonitorDataStructure data =
			(SnmpProtocolMonitorDataStructure) elements.get(key);

		SnmpProtocolMonitorValueTypeImpl snmpProtocolMonitorValueType =
			new SnmpProtocolMonitorValueTypeImpl(
				snmpInPktsGet(name),
				snmpOutPktsGet(name),
				snmpInBadVersionsGet(name),
				snmpInBadCommunityNamesGet(name),
				snmpInBadCommunityUsesGet(name),
				snmpInASNParseErrsGet(name),
				snmpInTooBigsGet(name),
				snmpInNoSuchNamesGet(name),
				snmpInBadValuesGet(name),
				snmpInReadOnlysGet(name),
				snmpInGenErrsGet(name),
				snmpInTotalReqVarsGet(name),
				snmpInTotalSetVarsGet(name),
				snmpInGetRequestsGet(name),
				snmpInGetNextsGet(name),
				snmpInSetRequestsGet(name),
				snmpInGetResponsesGet(name),
				snmpInTrapsGet(name),
				snmpOutTooBigsGet(name),
				snmpOutNoSuchNamesGet(name),
				snmpOutBadValuesGet(name),
				snmpOutGenErrsGet(name),
				snmpOutGetRequestsGet(name),
				snmpOutGetNextsGet(name),
				snmpOutSetRequestsGet(name),
				snmpOutGetResponsesGet(name),
				snmpOutTrapsGet(name),
				snmpEnableAuthenTrapsGet(name),

				data.name,
				data.objectclass,
				data.packages,
				data.sourceIndicator,
				data.deletePolicy
			);
			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "attributesGet finished successfully");
			return snmpProtocolMonitorValueType;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::packagesGet operation.
     */
    public String[]
    packagesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		SnmpProtocolMonitorDataStructure data =
			(SnmpProtocolMonitorDataStructure) elements.get(key);

        return data.packages;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::creationSourceGet operation.
     */
    public intt.itu.itut_x780.SourceIndicatorType
    creationSourceGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
         //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		SnmpProtocolMonitorDataStructure data =
			(SnmpProtocolMonitorDataStructure) elements.get(key);

		return data.sourceIndicator;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::deletePolicyGet operation.
     */
    public short
    deletePolicyGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		SnmpProtocolMonitorDataStructure data =
			(SnmpProtocolMonitorDataStructure) elements.get(key);

        return data.deletePolicy;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::destroy operation.
     */
    public void
    destroy(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_x780.DeleteError
    {
        //
        //  DONE : implement
        //

	if (!elements.containsKey(Utils.name2string(name))) {

            ApplicationErrorInfoTypeImpl error_code =
            new ApplicationErrorInfoTypeImpl();

            error_code.error = new UIDType(
            intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
            intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

            error_code.details = new String ("object with name " +
            Utils.name2string(name) + " does not exist.");

            throw new ApplicationError(error_code);

	}
	SnmpProtocolMonitorDataStructure snmpProtocolMonitorData = null;
	synchronized(elements) {
	    snmpProtocolMonitorData =
	 		(SnmpProtocolMonitorDataStructure) elements.remove(
			Utils.name2string(name));
	}
	org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
		0, (short) 0, (short) 0);
	get_context().push_objectDeletion(new ObjectDeletionImpl(eventTime, name,
						snmpProtocolMonitorData.objectclass,
						getUniqueNotificationIdentifier(),
//						ipProtocolMonitorData.getUniqueNotificationIdentifier(),
						snmpProtocolMonitorData.sourceIndicator,
						new AttributeValueType[0]));

		Utils.pretty_log(logSupport,  Utils.name2string(name),
			snmpProtocolMonitorData.objectclass, //objectClassGet(name),
		  (short) LogSeverity._Info,
		  "successfully removed from management system");

    }

	    protected static int getUniqueNotificationIdentifier() {

		notifId++;
        return notifId;
	}
}
