/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmsMibComponents.SnmpProtocolMonitorProviderComposition;

import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ObjectCreationImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.AttributeValueType;

import org.omg.CosNaming.NameComponent;
import ist.coach.coachEmfCommon.OperationalViolationImpl;

import ist.coach.coachEmfCommon.Utils;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/coachEmsMibComponents/SnmpProtocolMonitorProviderComposition/SnmpProtocolMonitorProviderHome_impl/SnmpProtocolMonitorProvider_impl/mgmtSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class mgmtSegImpl
     extends ist.coach.coachEmsMibComponents.SnmpProtocolMonitorProviderComposition.mgmtSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public mgmtSegImpl()
    {
    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::coachEmsMibComponents::SnmpProtocolMonitorMgmt::create operation.
     */
    public void
    create(org.omg.CosNaming.NameComponent[] name,
			    String objectClass,
				String[] packages,
				short deletePolicy,
				intt.itu.itut_x780.SourceIndicatorType sourceIndicator,
				org.omg.CosNaming.NameComponent[] superior,
				byte[] mgmtIpAddress,
				int supportedSnmpVersions,
				int snmpPort)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_x780.CreateError
    {
               //
        //  DONE : implement
        //

        if (SnmpProtocolMonitorProviderImpl.elements.containsKey(Utils.name2string(name))) {

            CreateErrorInfoTypeImpl errorCode =
                new CreateErrorInfoTypeImpl();

            errorCode.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.duplicateName.value);

            errorCode.details = new String(Utils.name2string(name) +
             " object already exists.");
            throw new intt.itu.itut_x780.CreateError(errorCode);
        }

		SnmpProtocolMonitorDataStructure snmpProtocolData =
			new SnmpProtocolMonitorDataStructure(
				name,
                objectClass,
                packages,
                sourceIndicator,
                deletePolicy,
                new String(mgmtIpAddress),
                snmpPort,
                supportedSnmpVersions);

		synchronized(SnmpProtocolMonitorProviderImpl.elements) {
		  SnmpProtocolMonitorProviderImpl.elements.put(Utils.name2string(name), snmpProtocolData);
		}

		ist.coach.coachEmfServices.SnmpAdapter.SnmpTrapDaemon config = null;
		if ((config = get_context().get_connection_config()) == null) {
			CreateErrorInfoTypeImpl errorCode =
				new CreateErrorInfoTypeImpl();

			errorCode.error = new UIDType(
				intt.itu.itut_x780.CreateErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			errorCode.details = new String(ExceptionMessages.components_connect_error);
			throw new intt.itu.itut_x780.CreateError(errorCode);
		}

		String ipAddress = new String();
        if (mgmtIpAddress != null)
			ipAddress = new String(mgmtIpAddress);

		try {
            config.registerIP(name, new String(ipAddress));
        }
        catch( ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError snmp_ex) {
            System.err.println("Could not register SnmpProtocolMonitor " +
                Utils.name2string(name) + " to the SNMP Trap Service");
            System.err.println("Reason= " + snmp_ex.reason);
            ApplicationErrorInfoTypeImpl error_code = new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.downstreamError.value);

            error_code.details = snmp_ex.reason;

            throw new ApplicationError(error_code);
        }

		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT (System.currentTimeMillis(),
                    0, (short) 0, (short) 0);
        get_context().push_objectCreation(new ObjectCreationImpl(eventTime,
                                                name,
                                                objectClass,
												SnmpProtocolMonitorProviderImpl.getUniqueNotificationIdentifier(),

                                                sourceIndicator,
                                                new AttributeValueType[0]));
    }

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::TrapCallback::notifyTrap operation.
     */
    public void
    notifyTrap(org.omg.CosNaming.NameComponent[] name, String community, int trapID, int trapType, ist.coach.coachEmfServices.SnmpAdapter.DataType[] trapData)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError
    {

        //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (SnmpProtocolMonitorProviderImpl.elements.containsKey(key) == false) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("SnmpProtocolMonitor object with name" +
			key + " does not exist.");

			throw new ApplicationError(error_code);
		}
		SnmpProtocolMonitorDataStructure data =
		  (SnmpProtocolMonitorDataStructure) SnmpProtocolMonitorProviderImpl.elements.get(key);

		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
						0,(short) 0,(short) 0);
		OperationalViolationImpl operationViolationEvent = new OperationalViolationImpl(
					    eventTime,
						data.name,
						data.objectclass,
						SnmpProtocolMonitorProviderImpl.getUniqueNotificationIdentifier());

		get_context().push_operationalViolation(operationViolationEvent);

    }

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::TrapCallback::facade_name operation.
     */
    public String
    facade_name()
    {
        //
        // TODO : Implement
        //
         return get_main_segment().facade_name();
    }

}
