/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA & USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): Mathieu Vadet.

====================================================================*/

package org.objectweb.ccm.IR3;

import org.omg.CORBA.ExceptionDef;

/**
 * Implementation of the CORBA::ExceptionDef reference.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.4
 */

public class ExceptionDef_ref
     extends IRObject_ref
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     * TODO.
     */
    public
    ExceptionDef_ref(IRObject_impl owner)
    {
        // Calls the IRObject_ref constructor.
        super(owner);
    }

    /**
     * TODO.
     */
    public
    ExceptionDef_ref(IRObject_impl owner,
                     ExceptionDef_impl object)
    {
        // Calls the IRObject_ref constructor.
        super(owner, object);
    }

    // ==================================================================
    //
    // Static public methods.
    //
    // ==================================================================

    /**
     * Cuts the dependency to a set of exceptions.
     */
    static public void
    cutDependencies(ExceptionDef_ref[] exceptions)
    {
        if (exceptions != null)
        {
            for(int i=0; i<exceptions.length; i++)
                exceptions[i].cutDependency();
        }
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Obtains its reference.
     */
    public ExceptionDef_impl
    getImpl()
    {
        return (ExceptionDef_impl)(super.getBaseImpl());
    }

    /**
     * Obtains its CORBA::ExceptionDef reference.
     */
    public ExceptionDef
    asExceptionDef()
    {
        return getImpl().asExceptionDef();
    }
}
