/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base;

/**
 * The DeployerScheduler interface specify all the method that a scheduler
 * must provide to schedule deployer processing.
 *
 * @author <a href="mailto:briclet@lifl.fr">Frederic Briclet</a>
 *
 * @version 0.1
 */
public interface DeployerScheduler {

    /**
     * The scheduler method is charge to start the processing of 
     * the @param deployers give in parameter. It is expected that
     * the scheduler invoke the visit() method on the @param deployer
     * for all the @param deployers in the most appropriate order.
     * 
     * @param deployer The deployer in charge to process @param deployers
     * @param deployers The deployers to process
     * @throws FatalDeploymentException Throws if the deployer encount a 
     * problem during the processing of the @param deployers. 
     */
    public void 
    traverse(Deployer deployer,Deployer [] deployers)
    throws FatalDeploymentException;
    
}
