/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.binder;

import org.objectweb.ccm.descriptor.componentassembly.Consumesport;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.util.CannotResolveReferenceException;
import org.omg.Components.InvalidName;

/**
 * This deployer is in charge to retrieve the consumer involve in the
 * current event connection.
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class ConsumesportDeployer
       extends ConsumesportDeployerContext 
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    /**
     * Return the event consumer describe in a event description
     * @exception CannotResolveReferenceException is thrown if the 
     * reference cannot be found.
     * @exception InvalidName is thrown if the port name define is invalid
     */     
    public org.omg.Components.EventConsumerBase 
    getConsumer() 
    throws CannotResolveReferenceException, InvalidName 
    {        
          org.omg.Components.CCMObject consumer ;
          Consumesport cp=getConsumesport();
          if(getComponentinstantiationDeployer()!=null)
              consumer =getComponentinstantiationDeployer().getComponent();                
        
          else consumer=org.omg.Components.
                        CCMObjectHelper.narrow(getFindbyDeployer().resolveReference());    
            
          return consumer.get_consumer(cp.getConsumesidentifier().getValue());
    }
}
