/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.installer;

// Local Interface Import Statements
import java.util.Iterator;
import org.objectweb.ccm.descriptor.componentassembly.beans.ComponentinstantiationBeanImpl;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.*;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.registrar.RegistercomponentDeployer;
/**
 * This handler is used to produce componentinstantiationDeployer from an
 * componentinstantiation bean .
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class ComponentinstantiationDeployerHandler 
       extends HandlerBase 
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    private ComponentinstantiationDeployer _deploy;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    /**
     * This initialization method is used to check that all the services and 
     * information required to deploy are presents. If all is OK the deployer 
     * is put in inactive deployer state waiting for the deployment processing.
     * 
     * @exception InitializationError is thrown if a problem is detected 
     */
    public Object 
    getInstance(ComponentinstantiationBeanImpl comp)
    throws InitializationError 
    {
        if(_deploy==null){
            _deploy=new ComponentinstantiationDeployer();
            _deploy.connectComponentinstantiation(comp);            
            applyCommonConfig(_deploy);
            if(comp.getComponentproperties()!=null)
            _deploy.connectComponentpropertiesDeployer
                ((ComponentpropertiesDeployer)getDeployer(comp.getComponentproperties()));
            if(comp.getRegistercomponentList()!=null)    
                for(Iterator it=comp.getRegistercomponentList().iterator();it.hasNext();){
                    _deploy.connectRegistercomponentDeployer
                        ((RegistercomponentDeployer)getDeployer(it.next()));
                }
            _deploy.connectComponentInstantiationDeployInfo
                ((ComponentinstantiationDeployInfo)
                  comp.getExtensionManager()
                      .getExtensionByName("ccm.deployer.installer.DeployInfo")
                      .getInstance());

           _deploy.initialize(); 
        }      
        return (_deploy);
    }
    
}
