/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.installer;

// Local Interface Import Statements
import org.objectweb.ccm.descriptor.componentassembly.beans.HomeplacementBean;
import org.objectweb.ccm.descriptor.componentassembly.beans.HostcollocationBeanImpl;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.HandlerBase;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.InitializationError;
/**
 * This handler is used to produce hostcollocationdeployer from an
 * hostcollocation bean .
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class HostcollocationDeployerHandler 
       extends HandlerBase 
  {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    private HostcollocationDeployer _deploy;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ================================================================== 
    /**
     * Produce the hostcollocation deployer binded
     * to the given @param host.
     * 
     * @param host The hostcollocation bean 
     * @return the deployer produced in initialize state
     * @throws InitializationError thrown if a problem is detected
     */ 
    public Object 
    getInstance(HostcollocationBeanImpl host)
    throws InitializationError 
    {
        if(_deploy==null){
            _deploy=new HostcollocationDeployer();
            _deploy.connectHostcollocation(host);
            applyCommonConfig(_deploy);
            DestinationDeployerBase ddb=(DestinationDeployerBase)
                                            getDeployer(host.getDestination());
            _deploy.connectDestinationDeployer(ddb);
            
            for(java.util.Iterator i=host.getHomeplacementList().iterator();i.hasNext(); ){
                 HomeplacementDeployer current=(HomeplacementDeployer)
                                     getDeployer((HomeplacementBean)i.next());
                 HostcollocationDestinationWrapper hdw=new HostcollocationDestinationWrapper();
                 hdw.connectWrappedDestination(ddb);
                 hdw.connectImplementationDeployer(current.getImplementationDeployer());
                 hdw.connectSoftpkgDeployer(current.getSoftpkgDeployer());
                 _deploy.connectHomeplacementDeployer(current);
                 current.connectDestinationDeployer(hdw);
                 current.initialize();
             } 
            _deploy.initialize();
        }
        
        return (_deploy);
    }

}
