/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Christophe Demarey.
Contributor(s): _______________________________.

====================================================================*/

package org.objectweb.ccm.runtime.cif.lib;

import org.omg.Components.EnterpriseComponent;
import org.omg.Components.ExecutorSegmentBase;
import org.objectweb.ccm.runtime.cif.api.ComponentSegment;

/**
 * Abstract base class for all component home classes generated from CIDL.
 *
 * This provides a create_enterprise_component method.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 0.1
 */

public abstract class HomeBase
        extends org.objectweb.corba.util.LocalObjectBase
     implements org.objectweb.ccm.runtime.cif.api.SegmentHome
{
    // ==================================================================
    //
    // Internal State.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /** The default constructor. */
    public
    HomeBase()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    /**
     * Create a component executor.
     *
     * @return The EnterpriseComponent created executor.
     */
    public EnterpriseComponent
    create_enterprise_component()
    {
        getLogger().trace(this, "Creating executor segment 0");
        ExecutorSegmentBase esb = create_executor_segment(0);

        getLogger().trace(this, "Setting segment home");
        ComponentSegment cs = (ComponentSegment)esb;
        cs.set_segment_home(this);

        return cs;
    }
}
