/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/

package org.objectweb.openccm.browser.CORBA;

/** The console's imports. */
import org.objectweb.util.browser.api.Entry;
import org.objectweb.util.browser.api.Wrapper;
import org.objectweb.util.browser.api.Context;
import org.objectweb.util.browser.core.naming.DefaultName;
import org.objectweb.util.browser.core.naming.DefaultEntry;

/**
 * Displays some attributes of a CORBA Object.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class CORBAContext
     extends CORBAAttributes
  implements Context, Wrapper {

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** The CORBA Object */
    protected org.omg.CORBA.Object component_ = null;

    // ==================================================================
    //
    // No Constructor.
    //
    // ==================================================================

    // ==================================================================
    //
    // No internal method.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for Context interface.
    //
    // ==================================================================

    public Entry[] getEntries() {
        java.util.Vector v = new java.util.Vector();
        for(int i=0 ; i<attributesName_.length ; i++){
            if(exists(attributesName_[i],component_)){
                String name = attributesName_[i];
                try{
                    Object returnValue = component_.getClass().getMethod(name,null).invoke(component_,null);
                    String value = returnValue!=null?returnValue.toString():null;
                    v.add(new DefaultEntry(new ViewAttributeWrapper(attributesName_[i],component_), new DefaultName(attributesName_[i] + ": " + value)));
                } catch(Exception e) {
                    ConsoleFactory.getDebugConsole().add("[" + getClass().getName() + "] " + name + "() method not found!\n");    
                }
                
            }
        }
        return (Entry[]) v.toArray(new Entry[0]); 
    }
    
    // ==================================================================
    //
    // Public methods for Wrapper interface.
    //
    // ==================================================================

    /**
     * Fix the wrapped object
     *
     * @param object The object to wrap
     *
     */
    public void setWrapped(Object object) {
        component_ = (org.omg.CORBA.Object) object;
    }

    /**
     * Gets the wrapped object
     *
     * @return The wrapped object
     *
     */
    public Object getWrapped() {
        return component_;
    }

}