/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/
package org.objectweb.openccm.browser.Components;

import javax.swing.JOptionPane;

import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.TreeView;
import org.omg.Components.CCMObject;
import org.omg.Components.PublisherDescription;
import org.omg.Components.SubscriberDescription;

/**
 * This item allows to unsubscribe a consumer from a given publisher
 * (<code>::Components::CCMObject::unsubscribe</code> called).
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * 
 * @version 0.1
 */
public class UnsubscribeAction 
    implements MenuItem {

    public int getStatus(TreeView arg0){
        return MenuItem.ENABLED_STATUS;
    }

    public void actionPerformed(MenuItemTreeView e) throws Exception {
        SubscriberContainer sc = (SubscriberContainer) e.getSelectedObject();
        CCMObject component = sc.getComponent();
        PublisherDescription publisher = sc.getPublisher();
        SubscriberDescription subscriber = sc.getSubscriber();
        component.unsubscribe(publisher.name, subscriber.ck);
    }

}
