/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Offroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.monolog.provider.lib.topics;

import java.io.PrintStream;
import java.util.HashMap;
import java.util.Iterator;

import org.objectweb.util.monolog.provider.lib.LoggerProviderSingleton;
import org.objectweb.util.monolog.provider.lib.TopicProviderSingleton;


/**
 * @author Jerome Offroy
 *
 * class used to store utilities for Topics
 *      - function to print names of Topics used and configured
 * 
 */
public class TopicTools {
    
    /**
     * display all the names configured for topics in the current JVM to out
     * @param out
     */
    static public void showAllTopics(PrintStream out){
        String [] tmp = LoggerProviderSingleton.getLoggerProvider().getTopics();
        out.println("configured Topics list");
        for (int i=0; i< tmp.length ; i++){ out.println(tmp[i]);}
    }
     
     /**
      * display all the names used for topics in the current JVM to out
      * @param out
      */
     static public void showAllUsedTopics(PrintStream out){
        String [] tmp = TopicProviderSingleton.getTopicProvider().getTopics();
        out.println("used Topics list");
        for (int i=0; i< tmp.length ; i++){ out.println(tmp[i]);}
    }

    /**
     * display all the key | names used for topics in the current JVM to out
     * @param out
     */    
    static public void showAllUsedTopicsWithRef(PrintStream out){
        //TODO make a good display
        HashMap tmp = TopicProviderSingleton.getTopicProvider().getTopicsByRef();
        Iterator it =   tmp.keySet().iterator();
        Class key = null;
        String value = "";
            out.println("key\t\t\t\t|\tvalue");
                    while(it.hasNext()){
            key = (Class )it.next(); 
            value = (String)tmp.get(key) ;
            out.println(key + "\t" + value);
        }
        
    }
}
