@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
rem # Contact: openccm@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Marc Navarro (mnavarro@wins.uva.nl),
rem #                       Philippe Merle.
rem # Contributor(s): Jerome Offroy, Briclet Frederic ---------------------.
rem #
rem # ====================================================================
rem #
rem # Installation of the OpenCCM Platform.
rem #
rem # ====================================================================

setlocal

rem # Check if the OpenCCM configuration directory exists.
if not exist %OpenCCM_CONFIG_DIR% goto :makecfg

echo Error: The OpenCCM Platform is already installed!
goto :eof

:makecfg

echo The OpenCCM Platform will be installed.

echo Creating the %OpenCCM_CONFIG_DIR% directory.
mkdir %OpenCCM_CONFIG_DIR%

echo Creating the %OpenCCM_CONFIG_DIR%\ComponentServers directory.
mkdir %OpenCCM_CONFIG_DIR%\ComponentServers

echo Creating the %OpenCCM_CONFIG_DIR%\NodeManagers directory.
mkdir %OpenCCM_CONFIG_DIR%\NodeManagers

echo Creating the %OpenCCM_CONFIG_DIR%\DCIManagers directory.
mkdir %OpenCCM_CONFIG_DIR%\DCIManagers

echo Creating the %OpenCCM_CONFIG_DIR%\AssemblyFactoryManagers directory.
mkdir %OpenCCM_CONFIG_DIR%\AssemblyFactoryManagers

echo Creating the %OpenCCM_CONFIG_DIR%\log directory.
mkdir %OpenCCM_CONFIG_DIR%\log
rem this directory store the default trace service config file

echo Copying the default Trace Service config file.
copy %OpenCCM_HOMEDIR%\xml\trace\monolog.CCM.properties %OpenCCM_CONFIG_DIR%\log\

echo The OpenCCM Platform is installed.
