/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.openccm.deployment.gui;

/**
 * This is a widget allowing to set a multi-line text
 *
 *
 * @author <a href="mailto:Christophe.Contreras@lifl.fr">Christophe Contreras</a>
 *
 */
public class TextArea
     extends javax.swing.JPanel
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** the swing text area */
    private javax.swing.JTextArea text_area;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     *  The default constructor.
     */
    public
    TextArea ()
    {
        // inits the text area
        text_area = new javax.swing.JTextArea("", 5, 30);

        this.setLayout(new java.awt.BorderLayout());

        javax.swing.JPanel content = new javax.swing.JPanel();
//        content.setPreferredSize(new java.awt.Dimension(360,0));

        // building of the content panel with commas
        content.add(this.text_area);

        // adding the content to the panel
        this.add(content, java.awt.BorderLayout.CENTER);
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * The getter method
     */
    public String
    getBigText()
    {
        return this.text_area.getText();
    }

    /**
     * The setter method
     */
    public void
    setBigText (String text)
    {
        this.text_area.setText(text);
    }

}
