#!/bin/sh -f
# ====================================================================
#
# OpenCCM: The Open CORBA Component Model Platform
# Copyright (C) 2000-2004 USTL - LIFL - GOAL
# Contact: openccm@objectweb.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# Initial developer(s): Areski Flissi
# Contributor(s): 
#
# ====================================================================
#
# Set the IOR of the started NameService
#
# Usage: ns_set.sh <IOR | URL>
#
# ====================================================================

# ======================
# Eval the command line.
# ======================

if [ $# -lt 1 ]
then
    echo "usage: ns_set [IOR | URL]"
    exit 1
fi

ns_ior=$1

# ========================================
# Remove the current NameService.IOR file.
# ========================================

rm -f @OpenCCM_CONFIG_DIR@/NameService.IOR

# =================
# Save the new IOR.
# =================

echo $ns_ior > @OpenCCM_CONFIG_DIR@/NameService.IOR

echo "The CosNaming Service is set to $1."
