/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ________________________________________.

====================================================================*/

package org.objectweb.openccm.generator.java.ast.api;

import org.objectweb.openccm.generator.java.ast.api.StaticObject;

/**
 * This is the representation for java Attributes.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</A>
 */

public interface AttributeObject
         extends ObjectBase,
                 StaticObject
{
    /**
     * Set its type.
     *
     * @param type - The type to set.
     */
    public void
    setType(String type);

    /**
     * Obtain its type.
     *
     * @return Its type.
     */
    public String
    getType();

    /**
     * Set its initial value.
     *
     * @param value - The value to set.
     */
    public void
    setInitialValue(String value);

    /**
     * Obtain its initial value.
     *
     * @return Its initial value.
     */
    public String
    getInitialValue();
}
