/*====================================================================

ObjectWeb Util Preprocessor Package.
Copyright (C) 2004 INRIA & USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): ______________________________________.

--------------------------------------------------------------------
$Id: PreprocessorOption.java,v 1.1 2004/02/05 20:29:57 rouvoy Exp $
====================================================================*/

package org.objectweb.util.cpp.api;

import org.objectweb.util.cmdline.api.Option;

/**
 * This provides a common interface for all Preprocessor Options.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 * @version 0.1
 */
public interface PreprocessorOption
         extends Option,
                 PreprocessorHolder
{
    /**
     * Gets the base option label.
     *
     * @return The base option label.
     */
    public String
    getBaseOptionLabel();

    /**
     * Consumes the option value.
     *
     * @param current The option value.
     */
    public void
    consumeOption(String current);
}
