/*====================================================================

 ObjectWeb GoTM project - http://gotm.objectweb.org
 Contact: gotm@objectweb.org

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA

 Initial developer(s): Romain Rouvoy.
 Contributor(s): ______________________________________.

 ---------------------------------------------------------------------
 $Id: ReleaseSingleton.java,v 1.1 2004/02/27 19:07:20 rouvoy Exp $
 ====================================================================*/

package org.objectweb.util.release;

/**
 * ReleaseInfo Singleton.
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 * @version 0.1
 */
public class ReleaseSingleton 
{
    /** Instance of the ReleaseInfo to use. */
    protected static ReleaseInfo releaseInfo;
    
    /**
     * Defines the instance of ReleaseInfo to use.
     * @param info the instance of the ReleaseInfo to use.
     */
    public static void setReleaseInfo(ReleaseInfo info) {
        releaseInfo = info;
    }
    
    /**
     * Provides the instance of the ReleaseInfo used.
     * @return the instance of the ReleaseInfo used.
     */
    public static ReleaseInfo getReleaseInfo() {
        return releaseInfo;
    }
}
