/*====================================================================

created on 26 fvr. 03

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/

package org.objectweb.ccm.Containers.MetaInformation;

import org.omg.CORBA.Object;



/**
 * @author hameau
 */
public class InstanceImpl 
extends org.omg.CORBA.LocalObject
implements Instance 
{
  private Type          _type_reference;
  private Object        _object_ref;
  private instance_kind _instance_kind;
  private Instance      _instance_ref;

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.InstanceOperations#type_reference()
   */
  public Type type_reference()
  {
    return _type_reference;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.InstanceOperations#type_reference(org.objectweb.ccm.Containers.MetaInformation.Type)
   */
  public void type_reference(Type value)
  {
   // System.err.println("### DEBUG : instance type ref -> " + value);
    _type_reference = value;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.InstanceOperations#object_ref()
   */
  public Object object_ref()
  {
    return _object_ref;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.InstanceOperations#object_ref(org.omg.CORBA.Object)
   */
  public void object_ref(Object value)
  {
    _object_ref = value;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.InstanceOperations#related_instance_kind()
   */
  public instance_kind related_instance_kind()
  {
    return _instance_kind;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.InstanceOperations#related_instance_kind(org.objectweb.ccm.Containers.MetaInformation.instance_kind)
   */
  public void related_instance_kind(instance_kind value)
  {
    _instance_kind = value;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.InstanceOperations#instance_reference()
   */
  public Instance instance_reference()
  {
     return _instance_ref;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.InstanceOperations#instance_reference(org.objectweb.ccm.Containers.MetaInformation.Instance)
   */
  public void instance_reference(Instance value)
  {
    _instance_ref = value;
  }

	
}
