/*====================================================================

created on 18 aot 2003
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/
package org.objectweb.ccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;
import org.omg.Components.InvalidName;


/**
 * @author hameau
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class OperationInstanceListImpl
extends LocalObject
implements OperationInstanceList
{
  private Table _operations; 
  
   public OperationInstanceListImpl()
   {
     _operations = new Table();
   }

   /* (non-Javadoc)
    * @see org.objectweb.ccm.Containers.MetaInformation.OperationInstanceListOperations#get_operation_instance(java.lang.String)
    */
   public OperationInstance 
   get_operation_instance(String name) 
   throws InvalidName
   {
     OperationInstance result = (OperationInstance) _operations.get(name);
     if(result == null)
       throw new InvalidName();
     return result;
   }

   /* (non-Javadoc)
    * @see org.objectweb.ccm.Containers.MetaInformation.OperationInstanceListOperations#get_named_operation_instances(java.lang.String[])
    */
   public OperationInstance[] 
   get_named_operation_instances(String[] names) 
   throws InvalidName
   {
     OperationInstance[] result = new OperationInstance[names.length];

    // Iterate on all the connections.
  
    int i = 0;
    for(i=0;i<names.length;i++)
    {
      result[i] = (OperationInstance)_operations.get(names[i]);
     
      if(result[i] == null)
      {
        throw new InvalidName();
      }
     }
   
    return result;
   }

   /* (non-Javadoc)
    * @see org.objectweb.ccm.Containers.MetaInformation.OperationInstanceListOperations#get_all_operation_instances()
    */
   public OperationInstance[] 
   get_all_operation_instances()
   {
     OperationInstance[] result = new OperationInstance[_operations.size()];
  
      // Iterate on all the connections.
      int idx = 0;
      for(java.util.Enumeration enum = _operations.elements(); enum.hasMoreElements(); )
      {
        OperationInstance info = (OperationInstance)enum.nextElement();
          result[idx++] = info;
      }
      return result;
   }

   /* (non-Javadoc)
    * @see org.objectweb.ccm.Containers.MetaInformation.OperationInstanceListOperations#add_operation_instance(org.objectweb.ccm.Containers.MetaInformation.OperationInstance)
    */
   public void add_operation_instance(OperationInstance cpi)
   {
     String key = cpi.type_reference().name() + cpi.toString().substring(cpi.toString().lastIndexOf("@"));
     _operations.put(key,cpi);
    
   }

   /* (non-Javadoc)
    * @see org.objectweb.ccm.Containers.MetaInformation.OperationInstanceListOperations#remove_operation_instance(java.lang.String)
    */
   public void remove_operation_instance(String name) 
   throws InvalidName
   {
     Object result = _operations.remove(name);
    
     if (result == null) throw new InvalidName();
   }
}
